
#ifndef __OEM_H_
#define __OEM_H_

#define OEM_SYS_SOCK_EVENT_CONNECT_OK 	0
#define OEM_SYS_SOCK_EVENT_RECV_DATA	1
#define OEM_SYS_SOCK_EVENT_SHUT_IND		2
#define OEM_SYS_SOCK_EVENT_ERROR_IND	3

typedef enum{
	OEM_TUP_TCP,
	OEM_TUP_UDP
}OEM_TUP_ENUM;

typedef void OEM_sock;
typedef void *OEM_que;
typedef int (*OEM_SYS_TASK_FUN)(void *param);
typedef void (*OEM_SYS_LOG_FUN)(char *msg);
typedef void (*OEM_SYS_SOCK_FUN)(char event,char *name,unsigned char *msg, int msg_len,void *param);

void *OEM_sys_malloc(unsigned int byteSize);
void OEM_sys_free(void *data);

void OEM_sys_set_pcid(int pcid);
int OEM_sys_get_hid(char *outmsg, int msglen);
int OEM_sys_task_new(OEM_SYS_TASK_FUN fun, int task_stack_k, int priority, const char *taskName,void *param);

int OEM_sys_log_init(OEM_SYS_LOG_FUN fun);
void OEM_sys_log_print(const char *mark,const char *level,char * fmt, ...);

int OEM_sys_ppp_ready(void);
int OEM_sys_dns(char *dns, char *outIp, int outIpSize);

OEM_sock *OEM_sys_sock_connect(OEM_TUP_ENUM tup, char *ip, unsigned short port,OEM_SYS_SOCK_FUN fun,int *ret,int task_stack_k,int priority,const char *taskName, void *usr_data);
int OEM_sys_sock_close(OEM_sock *handle);
int OEM_sys_sock_send_data(OEM_sock *handle, unsigned char *data, int datalen);
unsigned int OEM_sys_get_tick(void);

int OEM_sys_queue_new(OEM_que *handle,unsigned int msgsize, unsigned int msgnum);
int OEM_sys_queue_wait(OEM_que hande, unsigned char *msgBuf, unsigned int msgBufSize);
int OEM_sys_queue_send(OEM_que handle, unsigned char *msgBuf, unsigned int msgBufSize);
int OEM_sys_queue_del(OEM_que handle);

#endif
